• 2015 HUAS Summer Trainning #4 C


    My birthday is coming up and traditionally I’m
    serving pie. Not just one pie, no, I have a number
    N of them, of various tastes and of various sizes. F
    of my friends are coming to my party and each of
    them gets a piece of pie. This should be one piece
    of one pie, not several small pieces since that looks
    messy. This piece can be one whole pie though.
    My friends are very annoying and if one of them
    gets a bigger piece than the others, they start complaining.
    Therefore all of them should get equally
    sized (but not necessarily equally shaped) pieces,
    even if this leads to some pie getting spoiled (which
    is better than spoiling the party). Of course, I want
    a piece of pie for myself too, and that piece should also be of the same size.
    What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and
    they all have the same height 1, but the radii of the pies can be different.

    Input
    One line with a positive integer: the number of test cases. Then for each test case:
    • One line with two integers N and F with 1 ≤ N, F ≤ 10000: the number of pies and the number
    of friends.
    • One line with N integers ri with 1 ≤ ri ≤ 10000: the radii of the pies.

    Output
    For each test case, output one line with the largest possible volume V such that me and my friends can
    all get a pie piece of size V . The answer should be given as a oating point number with an absolute
    error of at most 10−3
    .
    Sample Input
    3
    3 3
    4 3 3
    1 24
    5
    10 5
    1 4 2 3 4 5 6 5 4 2
    Sample Output
    25.1327
    3.1416
    50.2655

    题目大意:给你N个蛋糕,k+1个人,问每个人能获得的最大体积的蛋糕是多少。

    解题思路:m=选出最大的蛋糕体积/k+1人,p=全部蛋糕的体积和/k+1;

    每次用m+p/2,来除以每个蛋糕的体积,如果人数相等或大于,这个体积就是最大的。

    代码:

     1 #include<iostream>
     2 #include<algorithm>
     3 #include<cstdio>
     4 #include<cmath>
     5 #include<cstring>
     6 using namespace std;
     7 const double pi=acos(-1.0);
     8 const int maxn=10000+10;
     9 int main()
    10 {
    11     int T,N,F,i,c;
    12     double l,r,mid,a[maxn],sum;
    13     scanf("%d",&T);
    14     while(T--)
    15     {
    16         memset(a,0,sizeof(a));
    17         scanf("%d%d",&N,&F);
    18         F++;
    19         sum=0;
    20         for(i=0;i<N;i++)
    21         {
    22             scanf("%d",&c);
    23             a[i]=pi*c*c;
    24             sum+=a[i];
    25         }
    26         sort(a,a+N);
    27         l=a[N-1]/F;
    28         r=sum/F;
    29         while(r-l>1e-6)
    30         {
    31             int count=0;
    32             mid=(l+r)/2;
    33             for(i=0;i<N;i++)
    34                 count+=(int)floor(a[i]/mid);
    35             if(count>=F)
    36                 l=mid;
    37             else r=mid;
    38         }
    39         printf("%.4f
    ",l);
    40     }
    41     return 0;
    42 }
    View Code
  • 相关阅读:
    10g full join 优化
    推荐C++程序员阅读《CLR via C#》
    密码安全之动态盐
    徒弟们对话,遇到sb领导,离职吧
    hdu 1698 线段数的区间更新 以及延迟更新
    嗯。。 差不多是第一道自己搞出的状态方程 hdu4502 有一点点变形的背包
    嗯 第二道线段树题目 对左右节点和下标有了更深的理解 hdu1556
    hdu 4501三重包问题
    入手线段树 hdu1754
    hdu 5672 尺取还是挺好用的
  • 原文地址:https://www.cnblogs.com/huaxiangdehenji/p/4716283.html
Copyright © 2020-2023  润新知